<?php

/*****************************************************************************
 * 
 * サンプルのため、冗長なコメントになっています。
 * 
 ****************************************************************************/

/**
 * サンプルのため、定数定義をこのファイル内に記述しています。
 * 本来は、Lambda/apps/<APP_DIR>/app.conf.php に定義することが推奨されます。
 */
// ドライラン： アップロードを行う = 0 | アップロードを行わない = 1
//
//   ※ サンプルのため、この定数を定義しています。本来は不要です。
//      また、ロジックとビューでこの定数を参照しているステートメントも不要になります。
define('FILEUPLOAD_DRYRUN', 1);

// アップロードされたファイルを格納するディレクトリ
define('UPL_DIR', APP_DIR.'/upload');

// アップロードを許可する最大ファイルサイズ(1ファイルにつき)(単位：MB)
define('IMAGE_MAX_SIZE', 1);

/**
 * リクエストが「http://example.com/fileupload」のように、/ (スラッシュ)で
 * 終わっていない場合、/ (スラッシュ)付きURLにリダイレクトする。
 *
 *   ビュー(index.view.php)の <form action="" ... > にて、
 *   
 *     <form action="<?php echo APP_ROOT ?>/fileupload/" ... >
 *   
 *   上記のように、モジュールグループを直接記述すれば、
 *   このステートメントは不要になります。
 *   ※ 本来は、上記のように直接記述することが推奨されます。
 *   
 *   本モジュールはサンプルのため、環境に依存した記述を減らし、
 *   設置の誤りを防ぐ意味で、下記のように <form action> の値を動的に
 *   生成している都合上、このようなリダイレクト処理が必要になっています。
 *   
 *   <form action="<?php echo $lmd->httpRequestDir() ?>/">
 */
if (substr($lmd->httpRequestUri(), -11) === '/fileupload') {
    $lmd->redirect($lmd->httpRequestUri().'/');
    exit;
}

/**
 * ジャバスクリプトライブラリのロード
 * 
 *   ジャバスクリプトライブラリは、Lambda/libs/Javascript.php にあります。
 * 
 * [tips]
 * よく使うライブラリは、Lambda/apps/<APP_DIR>/app.init.php で事前にロードしておくとよい。
 */
Factory::import('Javascript');

if ( ! $lmd->hasHttpPost('upload')) {
    /**
     * 【アップロードする】ボタンが押されていない。
     * 
     *   ⇒ デフォルト画面に遷移させる。
     * 
     * ※ ガード節
     */
    return $lmd->setPrep('fileupload.index');
}

/**
 * パラメータを定義
 * 
 * array('フィールドラベル', '最大ファイルサイズ', '単位', '許可するファイル拡張子の正規表現')
 */
$params = array();
$params['image'][1] = array('画像1', IMAGE_MAX_SIZE, 'MB', '/^(gif|jpe?g|png)$/i');
$params['image'][2] = array('画像2', IMAGE_MAX_SIZE, 'MB', '/^(gif|jpe?g|png)$/i');
$params['image'][3] = array('画像3', IMAGE_MAX_SIZE, 'MB', '/^(gif|jpe?g|png)$/i');

/**
 * アップロードライブラリをロード/インスタンス化して、アップロード対象ディレクトリを指定する。
 */
$upload = Factory::load('Upload')->getInstance($params)->setUploadDir(UPL_DIR);

/**
 * アップロード実行
 */
$res = true;
if ( ! FILEUPLOAD_DRYRUN) {
    $res = $upload->execute();
}
if ($res === false) {
    /**
     * アップロード失敗
     */
    Javascript::backHistory($upload->getErrMsg(), '#ffa07a');
} elseif (FILEUPLOAD_DRYRUN) {
    /**
     * ドライラン
     */
    Javascript::redirect($lmd->httpRequestDir().'/', 'サンプルのため、アップロードしません');
} else {
    /**
     * アップロード成功
     */
    $lmd->redirect($lmd->httpRequestDir().'/');
}


